package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.LandmarkType;
import com.izouma.awesomeadmin.service.LandmarkTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/landmarkType")
public class LandmarkTypeController {

    @Autowired
    private LandmarkTypeService landmarkTypeService;

    /**
     * <p>获取全部记录。</p>
     */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(LandmarkType record) {
        List<LandmarkType> pp = landmarkTypeService.getLandmarkTypeList(record);
        return new Result(true, pp);
    }

    @RequestMapping(value = "/allArea", method = RequestMethod.GET)
    @ResponseBody
    public Result allArea(LandmarkType record) {
        List<LandmarkType> pp = landmarkTypeService.getLandmarkTypeAllAreaList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getLandmarkType", method = RequestMethod.GET)
    @ResponseBody
    public Result getLandmarkType(@RequestParam(required = false, value = "id") String id) {
        LandmarkType data = landmarkTypeService.getLandmarkTypeById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(LandmarkType record) {
        LandmarkType data = landmarkTypeService.getLandmarkType(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, LandmarkType record) {
        Map<String, Object> result = new HashMap<>();

        List<LandmarkType> pp = landmarkTypeService.getLandmarkTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(LandmarkType record) {
        boolean num = landmarkTypeService.createLandmarkType(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateLandmarkType(LandmarkType record) {
        boolean num = landmarkTypeService.updateLandmarkType(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteLandmarkType(LandmarkType record) {

        boolean num = landmarkTypeService.deleteLandmarkType(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, LandmarkType record) throws Exception {

        List<LandmarkType> landmarkTypes = landmarkTypeService.getLandmarkTypeList(record);


        String sheetName = "landmark_type";
        String titleName = "类别管理数据表";
        String fileName = "类别管理表";
        int columnNumber = 13;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"ID", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "类别类型", "类别名称", "区域命名", "事物命名", "icon", "备注", "权限"};
        String[][] dataList = new String[landmarkTypes.size()][13];

        for (int i = 0; i < landmarkTypes.size(); i++) {

            dataList[i][0] = String.valueOf(landmarkTypes.get(i).getId());
            dataList[i][1] = String.valueOf(landmarkTypes.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(landmarkTypes.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(landmarkTypes.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(landmarkTypes.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(landmarkTypes.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(landmarkTypes.get(i).getTypeFlag());
            dataList[i][7] = String.valueOf(landmarkTypes.get(i).getTypeName());
            dataList[i][8] = String.valueOf(landmarkTypes.get(i).getAreaName());
            dataList[i][9] = String.valueOf(landmarkTypes.get(i).getThingName());
            dataList[i][10] = String.valueOf(landmarkTypes.get(i).getIcon());
            dataList[i][11] = String.valueOf(landmarkTypes.get(i).getRemark());
            dataList[i][12] = String.valueOf(landmarkTypes.get(i).getPower());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

